PROGRAM_NAME='Marantz_DV9500_Main'
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 03/10/2005  AT: 13:15:35              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 05/25/2005  AT: 12:29:45        *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 03/28/2005                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
dvTP      = 10001:1:0           (* NXT-CV12 TOUCH PANEL *)
dvDevice  =  5001:1:0           (* Marantz Dv 9500     	*)
vdvDevice = 41001:1:0           (* VIRTUAL DEVICE       *)

// CABLE NEEDED IS FG#10-889

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

INTEGER nCHAN_BTN[] =                   // CHANNEL BUTTONS ON TOUCH PANEL
{
	1,	//-POWER OFF
	2,	//-POWER ON
	3,	//-PLAY
	4,	//-PAUSE
	5,	//-STOP
	6,	//-SCAN FORWARD
	7,	//-SCAN BACKWARD
	8,	//-SKIP FORWARD
	9,	//-SKIP BACKWARD
	10,	//-FRAME FORWARD
	11,	//-DISPLAY OSD TOGGLE
	12,	//-REPEAT
	13,	//-RANDOM
	14,	//-CURSOR UP
	15,	//-CURSOR DOWN
	16,	//-CURSOR LEFT
	17,	//-CURSOR RIGHT
	18,	//-CURSOR SELECT
	19,	//-MENU BUTTON
	20,	//-A-B REPEAT
	21,	//-ANGLE
	22,	//-SUBTITLE
	23,	//-PAGE UP
	24,	//-PAGE DOWN
	25,	//-RETURN
	26,	//-AUDIO
	27,	//-TOP MENU
	28,	//-DIMMER
	29,	//-KEYPAD CLEAR
	30,	//-KEYPAD 0
	31,	//-KEYPAD 1
	32,	//-KEYPAD 2
	33,	//-KEYPAD 3
	34,	//-KEYPAD 4
	35,	//-KEYPAD 5
	36,	//-KEYPAD 6
	37,	//-KEYPAD 7
	38,	//-KEYPAD 8
	39,	//-KEYPAD 9
	40,	//-KEYPAD +10
	41,	//-ZOOM
	42,	//-PROGRAM
	43,	//-SEARCH TOGGLE
	44,	//-TRAY TOGGLE
	45,	//-SLOW FORWARD
	46 	//-SLOW REVERSE
}

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

DEFINE_MODULE 'Marantz_DV9500_Comm' DuetCode(vdvDevice, dvDevice)
DEFINE_MODULE 'Marantz_DV9500_UI'   TP1(vdvDevice, dvTP, nCHAN_BTN)
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)