MODULE_NAME='Marantz_DV9500_UI' (DEV vdvDevice, DEV dvTP, INTEGER nCHAN_BTN[])
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 03/10/2005  AT: 13:15:35              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 05/25/2005  AT: 12:29:43        *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 03/28/2005                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

#INCLUDE 'SNAPI.AXI'
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR sVERSION[5] = ''   // STORES NETLINX COMM MODULE VERSION NUMBER
VOLATILE INTEGER nDEBUG = 0      // TRACKS THE ON/OFF STATE OF DEBUG MSGS SENT TO THE TELNET SESSION
VOLATILE CHAR cCOMMAND[20][20]
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
//
// Function : fnPARSE()
// Purpose  : STRING PARSING USING A DELIMITER
// Params   : CHAR cDELIMITER[], CHAR cSTRING[], CHAR cNEW_STRING[][]
// Return   : nCOUNTER
// Notes    : THIS FUNCTION PARSES A STRING USING A DELIMITER PASSED BY THE USER. 
//            MAXIMUM OF 10 PARAMETERS OF LENGTH 50 EACH- DELIMITER CAN HAVE LENGTH 1 OR 2.
//            THIS FUNCTION RETURNS THE NUMBER OF PARAMETERES PARSED. cNEW_STRING CONTAINS THE PARSED INFO.

DEFINE_FUNCTION INTEGER fnPARSE(CHAR cDELIMITER[2], CHAR cSTRING[500], CHAR cNEW_STRING[11][50])
{
	STACK_VAR INTEGER nCOUNTER
	nCOUNTER=0
	WHILE(nCOUNTER<=10)
	{
		IF(FIND_STRING(cSTRING,"cDELIMITER",1))  
		{
			cNEW_STRING[nCOUNTER+1]=REMOVE_STRING(cSTRING,"cDELIMITER",1)
			SET_LENGTH_STRING(cNEW_STRING[nCOUNTER+1],LENGTH_STRING(cNEW_STRING[nCOUNTER+1])-LENGTH_STRING(cDELIMITER))
			nCOUNTER++
		}
		ELSE
		{
			cNEW_STRING[nCOUNTER+1]=cSTRING
			IF(LENGTH_STRING(cSTRING))
				nCOUNTER++
			BREAK  
		}
	}
	RETURN nCOUNTER
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT


DATA_EVENT[vdvDEVICE]
{
	COMMAND:
	{
		STACK_VAR CHAR DATUM[30]
		
        send_string 0, "'UI/Virtual Device 1 received from Comm: ',data.text"
        datum  = remove_string(data.text, '-', 1)
        
        SWITCH(DATUM)
		{
			// FIND MATCHING STRING AND PARSE REST OF MESSAGE. PROVIDE FEEDBACK TO THE 
			// TOUCH PANEL.
			CASE 'DEBUG-': 
			{	nDEBUG = ATOI(DATA.TEXT) 
				IF (nDebug >= 3) 
					SEND_STRING 0, "'Debug messages are now on.'"
                ELSE IF(nDEBUG < 3)
					SEND_STRING 0, "'Debug messages are now off.'"
			}
			CASE 'TITLECOUNTER-':
			{
				SEND_COMMAND dvTP, "'@TXT',1,DATA.TEXT" //(DATA.TEXT,8)"//REMOVE THE FRAME PART
			}
			CASE 'TITLEINFO-':
			{
				fnPARSE(',',DATA.TEXT,cCOMMAND)
				IF(cCOMMAND[1] == '-2147483648')
				{
					SEND_COMMAND dvTP, "'@TXT',3,'Title --'"//TITLE
				}
				ELSE
				{
					SEND_COMMAND dvTP, "'@TXT',3,'Title ',cCOMMAND[1]"//TITLE
				}				
			}
			CASE 'TRACKCOUNTER-':
			{
				SEND_COMMAND dvTP, "'@TXT',1,DATA.TEXT" //(DATA.TEXT,8)"//REMOVE THE FRAME PART
			}
			CASE 'TRACKINFO-':
			{
				fnPARSE(',',DATA.TEXT,cCOMMAND)
				IF(cCOMMAND[1] == '-2147483648')
				{
					SEND_COMMAND dvTP, "'@TXT',2,'Chapter/Track -- '"//CHAPTER
				}
				ELSE
				{
					SEND_COMMAND dvTP, "'@TXT',2,'Chapter/Track ',cCOMMAND[1]"//CHAPTER
				}
			}
			CASE 'VERSION-': 
			{
				sVERSION = DATA.TEXT 
			}
		}// END SWITCH(datum)
	}// END COMMAND
}// END DATA_EVENT[vdvDEVICE]


DATA_EVENT[dvTP]
{
	ONLINE: 
	{
		SEND_COMMAND dvTP, "'@PPX'"
	}
}// END DATA_EVENT[dvTP]

BUTTON_EVENT[dvTP, nCHAN_BTN]
{
	PUSH:
	{
		STACK_VAR INTEGER nBTN
		
		nBTN = GET_LAST(nCHAN_BTN)
		SWITCH(nBTN)
		{
			CASE 1:		//POWER OFF
			{
				PULSE[vdvDevice,PWR_OFF]
			}
			CASE 2:		//POWER ON
			{
				PULSE[vdvDevice,PWR_ON]
			}
			CASE 3:		//PLAY
			{
				PULSE[vdvDevice,PLAY]
			}
			CASE 4:		//PAUSE
			{
				PULSE[vdvDevice,PAUSE]
			}
			CASE 5:		//STOP
			{
				PULSE[vdvDevice,STOP]
			}
			CASE 6:		//SCAN FORWARD
			{
				PULSE[vdvDevice,SFWD]
			}
			CASE 7:		//SCAN BACKWARD
			{
				PULSE[vdvDevice,SREV]
			}
			CASE 8:		//SKIP FORWARD
			{
				PULSE[vdvDevice,FFWD]
			}
			CASE 9:		//SKIP BACKWARD
			{
				PULSE[vdvDevice,REW]
			}
			CASE 10:	//FRAME FORWARD
			{
				PULSE[vdvDevice,FRAME_FWD]
			}
			CASE 11:	//DISPLAY OSD TOGGLE
			{
				PULSE[vdvDevice,MENU_DISPLAY]
			}
			CASE 12:	//REPEAT
			{
				PULSE[vdvDevice,DISC_REPEAT]
			}
			CASE 13:	//RANDOM
			{
				PULSE[vdvDevice,DISC_RANDOM]
			}
			CASE 14:	//CURSOR UP
			{
				PULSE[vdvDevice,MENU_UP]
			}
			CASE 15:	//CURSOR DOWN
			{
				PULSE[vdvDevice,MENU_DN]
			}
			CASE 16:	//CURSOR LEFT
			{
				PULSE[vdvDevice,MENU_LT]
			}
			CASE 17:	//CURSOR RIGHT
			{
				PULSE[vdvDevice,MENU_RT]
			}
			CASE 18:	//CURSOR SELECT
			{
				PULSE[vdvDevice,MENU_SELECT]
			}
			CASE 19:	//MENU BUTTON
			{
				PULSE[vdvDevice,MENU_FUNC]
			}
			CASE 20:	//A-B REPEAT
			{
				PULSE[vdvDevice,MENU_AB_REPEAT]
			}
			CASE 21:	//ANGLE
			{
				PULSE[vdvDevice,MENU_ANGLE]
			}
			CASE 22:	//SUBTITLE
			{
				PULSE[vdvDevice,MENU_SUBTITLE]
			}
			CASE 23:	//PAGE UP
			{
				PULSE[vdvDevice,MENU_PAGE_UP]
			}
			CASE 24:	//PAGE DOWN
			{
				PULSE[vdvDevice,MENU_PAGE_DN]
			}
			CASE 25:	//RETURN
			{
				PULSE[vdvDevice,MENU_RETURN]
			}
			CASE 26:	//AUDIO
			{
				PULSE[vdvDevice,MENU_AUDIO_MENU]
			}
			CASE 27:	//TOP MENU
			{
				PULSE[vdvDevice,MENU_TOP_MENU]
			}
			CASE 28:	//DIMMER
			{
				PULSE[vdvDevice,MENU_DIMMER]
			}
			CASE 29:	//KEYPAD CLEAR
			{
				PULSE[vdvDevice,MENU_CLEAR]
			}			
			CASE 30:	//KEYPAD 0
			{
				PULSE[vdvDevice,DIGIT_0]
			}
			CASE 31:	//KEYPAD 1
			{
				PULSE[vdvDevice,DIGIT_1]
			}
			CASE 32:	//KEYPAD 2
			{
				PULSE[vdvDevice,DIGIT_2]
			}
			CASE 33:	//KEYPAD 3
			{
				PULSE[vdvDevice,DIGIT_3]
			}
			CASE 34:	//KEYPAD 4
			{
				PULSE[vdvDevice,DIGIT_4]
			}
			CASE 35:	//KEYPAD 5
			{
				PULSE[vdvDevice,DIGIT_5]
			}
			CASE 36:	//KEYPAD 6
			{
				PULSE[vdvDevice,DIGIT_6]
			}
			CASE 37:	//KEYPAD 7
			{
				PULSE[vdvDevice,DIGIT_7]
			}
			CASE 38:	//KEYPAD 8
			{
				PULSE[vdvDevice,DIGIT_8]
			}
			CASE 39:	//KEYPAD 9
			{
				PULSE[vdvDevice,DIGIT_9]
			}
			CASE 40:	//KEYPAD +10
			{
				PULSE[vdvDevice,MENU_PLUS_10]
			}
			CASE 41:	//ZOOM
			{
				PULSE[vdvDevice,MENU_ZOOM]
			}			
			CASE 42:	//PROGRAM
			{
				PULSE[vdvDevice,MENU_PROGRAM]
			}	
			CASE 43:	//SEARCH TOGGLE
			{
				PULSE[vdvDevice,67]
			}
			CASE 44:	//TRAY TOGGLE
			{
				PULSE[vdvDevice,120]	
			}
			CASE 45:	//SLOW FORWARD
			{
				PULSE[vdvDevice,SLOW_FWD]
			}
			CASE 46: 	//SLOW REVERSE
			{
				PULSE[vdvDevice,SLOW_REV]
			}
			
		}// END SWITCH(nBTN)
	}// END PUSH
}// END BUTTON_EVENT[dvTP, nCHAN_BTN]
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

[dvTP,nCHAN_BTN[1]] 	=!	[vdvDEVICE,POWER_FB]
[dvTP,nCHAN_BTN[2]] 	=	[vdvDEVICE,POWER_FB]
[dvTP,nCHAN_BTN[3]] 	=	[vdvDEVICE,PLAY_FB]
[dvTP,nCHAN_BTN[4]] 	=	[vdvDEVICE,PAUSE_FB]
[dvTP,nCHAN_BTN[5]] 	=	[vdvDEVICE,STOP_FB]
[dvTP,nCHAN_BTN[6]] 	=	[vdvDEVICE,SFWD_FB]
[dvTP,nCHAN_BTN[7]] 	=	[vdvDEVICE,SREV_FB]
[dvTP,nCHAN_BTN[45]] 	=	[vdvDEVICE,SLOW_REV_FB]
[dvTP,nCHAN_BTN[46]] 	=	[vdvDEVICE,SLOW_FWD_FB]


(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)